/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _STREAM_EDITOR_H_
#define _STREAM_EDITOR_H_

#include "Widget/lineeditclear.h"


#include <QDialog>
#include <QString>
#include <QTreeWidget>
#include <QStatusBar>
#include <QAction>

/*
********************************************************************************
*                                                                              *
*    Class StreamEditor                                                        *
*                                                                              *
********************************************************************************
*/
class StreamEditor : public QDialog 
{
Q_OBJECT

public: 
  StreamEditor(QWidget *parent);
  ~StreamEditor();
    
  void load_stream_file(const QString& path);
  
private:
  void create_ui();

  QTreeWidget*         m_treeWidget;
  LineEditClear*       ui_line_edit;          // playlist name
  QStatusBar*          ui_status_bar;           

  QAction*             ui_save_action;
  QString              m_filepath;
  bool                 is_data_loading;
  
private slots:
  void slot_save_stream_list();
  void slot_on_buttonBox_rejected();
  void slot_delete_entry();
  void slot_add_entry();
  void slot_on_data_changed();

signals:
  void stream_list_saved();
};

#endif // _STREAM_EDITOR_H_
 
